# 模块1：FizzBuzz

**难度**：⭐️

**预计时长**：1小时

## 题目描述

这是一个简单的猜数字游戏。

想象你是个小学5年级的学生，现在还有5分钟就要下课，数学老师带全班同学玩一个小游戏。他会用手指挨个指向每个学生，被指着的学生就要依次报数：第一个被指着的学生说“1”，第二个被指着的学生说“2”，以此类推。

呃……并不完全“以此类推”……如果一个学生被指着的时候，应该报的数是3的倍数，那么他就不能说这个数，而是要说“Fizz”。同样的道理，5的倍数也不能被说出来，而是要说“Buzz”。

于是游戏开始了，老师的手指向一个个同学，他们开心地喊着：“1！”，“2！”，“Fizz！”，“4！”，“Buzz！”……终于，老师指向了你，时间仿佛静止，你的嘴发干，你的掌心在出汗，你仔细计算，然后终于喊出“Fizz！”。运气不错，你躲过了一劫，游戏继续进行。

为了避免在自己这儿失败，我们想了一个作弊的法子：最好能提前把整个列表打印出来，这样就知道到我这儿的时候该说什么了。全班有33个同学，游戏可能会玩2到3轮。

**任务：写一个程序，打印出从1到100的数字，将其中3的倍数替换成“Fizz”，5的倍数替换成“Buzz”。既能被3整除、又能被5整除的数则替换成“FizzBuzz”。**

程序的输出结果大致会是下面这样：

```
1
2
Fizz
4
Buzz
Fizz
7
8
Fizz
Buzz
11
Fizz
13
14
FizzBuzz
16
17
Fizz
19
Buzz
Fizz
...（中间省略若干行）
97
98
Fizz
Buzz
```

## 引导过程

## 迭代0：准备环境

运行下列命令，进入空的项目。

````Bash
git clone https://github.com/gigix/dojo-scaffold 
git checkout begin 
````

用IDE（建议IntelliJ IDEA）导入项目，项目中有一个测试，运行该测试通过即可。

### 迭代1：请学员自己写一遍

不讲课，直接展示题目，要求学员自己写一遍。限时15分钟。

提要求：单元测试覆盖率100%，并且没有重复代码。

经常有人把代码写成这样

```Java
public class FizzBuzz {
    public static void main(String[] args) {
        for (int i = 1; i <= 100; i++) {
            if (i % 15 == 0) {
                System.out.println("FizzBuzz");
                continue;
            }
            if (i % 3 == 0) {
                System.out.println("Fizz");
                continue;
            }
            if (i % 5 == 0) {
                System.out.println("Buzz");
                continue;
            }
            System.out.println(i);
        }
    }
}
```

讨论点：

1. 没有测试，且不具可测试性
1. 业务逻辑与IO混淆
1. 循环与主要处理逻辑混淆

### 迭代2：讲解测试驱动开发

讲解：什么是测试驱动开发。

用“计算器”的例子讲解。一个能做加法的计算器如何实现？先写测试，再写代码。

讨论，提出编程基本规则：

1. 没有失败的测试就不能写代码
1. 只能写恰好让测试通过的代码


### 迭代3：实现主体逻辑

演示一遍用TDD方法实现主体逻辑。引导师需事先练习，尤其注意：

1. 小步前进。
1. 快捷键的使用。

讨论：TDD的节奏 - 红/绿/重构

要求学员删掉现有代码，再练一遍。

计时，看大部分人的速度。请速度快的学员分享经验。

### 迭代4：速度快的秘诀

快捷键：介绍如何查看快捷键

现场演示 typing.io （引导师需先练习到50以上）

请学员练习。（注意：有些公司内网无法访问）

讨论：键盘速度快的必要性。

### 迭代5：新的需求

需求变更：

* 如果一个数能被3整除，或者包含数字3，那么这个数就是“Fizz”
* 如果一个数能被5整除，或者包含数字5，那么这个数就是“Buzz”

讨论：识别重复代码，用重构消除重复代码

演示Extract Method重构手法：

1. 旧的不变，新的创建：原来代码不动，创建一个无人使用的函数
1. 一步切换，旧的再见：将原来处理“可被整除”逻辑的代码逐个替换为使用新函数

讨论：对重构的误解

* 重构时机：随时留意坏味道，随时重构，不应该大批重构
* 重构方法：严格遵循重构手法，时刻保持行为不变

请学员从头开始完整练习。

### 项目小结

请学员讨论：学到了什么

* TDD的节奏
* 基本规则
	1. 没有失败的测试就不能写代码
	1. 只能写恰好让测试通过的代码
* 重构的要点
	* 重构时机：随时留意坏味道，随时重构，不应该大批重构
	* 重构方法：严格遵循重构手法，时刻保持行为不变

