# 模块3：参数解析



## 问题描述

我们经常会遇到需要解析命令行参数的场景。如果没有趁手的工具，我们可以自己写一个工具来处理命令行传入的参数。

传入一个程序的参数包含了“标记”（flag）和“值”（value）。标记都是一个字母，前面加上“-”号（例如“-p”这样）。每个标记都有一个值与之对应。例如一个服务端软件，运行它的命令行可能是这样：

> java -jar server.jar **-l true -p 8080 -d /usr/log**

上面这个命令行里，加粗的“`-l true -p 8080 -d /usr/log`”部分就叫“参数序列”。在这个例子里，上述参数序列包含的参数标记和值分别是：

* 参数“l”（logging，代表“是否记录日志”）：`true`（布尔型）
* 参数“p”（port，代表“端口号”）：`8080`（整数型）
* 参数“d”（directory，代表“日志输出的目录”）：`"/usr/log"`（字符串型）

而另一个客户端软件运行的命令行则可能是这样：

> java -jar client.jar **-s 192.168.0.1 -p 8080 -d true**

这个命令行里的参数序列部分是“`-s 192.168.0.1 -p 8080 -d true`”，其中包含的参数标记和值分别是：

* 参数“s”（server，代表“服务器IP地址”）：`"192.168.0.1"`（字符串型）
* 参数“p”（port，代表“端口号”）：`8080`（整数型）
* 参数“d”（daemon，代表“是否后台运行”）：`true`（布尔型）

**任务：我们要编写一个通用的类库，让不同的应用程序都可以使用这个类库来处理各自的命令行参数序列，并以合适的类型取出参数值。**